###generating sample
n<-800
x1<-rnorm(n)
x2<-rnorm(n)
x3<-rnorm(n)
x4<-rnorm(n)
epsilon<-rnorm(n)
y<-210+27.4*x1+13.7*(x2+x3+x4)+epsilon
alpha<-c(0,1,-0.5,0.25,0.1)
p<-(1+exp(alpha[1]+alpha[2]*x1+alpha[3]*x2+alpha[4]*x3+alpha[5]*x4))^{-1}
r<-rbinom(n,1,p)

z1<-exp(x1/2)
z2<-x2*(1+exp(x1))^{-1}+10
z3<-(x1*x3/25+0.6)^{3}
z4<-(x2+x4+20)^{2}

theta0<-mean(y)

###Parametric method
fit<-glm(r~z1+z2+z3+z4,family=binomial(link="logit"))
ep1<-fit$fitted.values
etheta_P<-1/n*sum(r/ep1*y)

###Semi/Nonparametric method

#Create cell by using covariates
library(rpart)
fit<-rpart(r~z1+z2+z3+z4)
plot(fit)
text(fit,use.n=TRUE)
ep2<-predict(fit)
etheta_WC_Cov<-1/n*sum(r/ep2*y)

#Create cell by using estimated propensity scores

fp<-function(x0,G){
n0<-length(x0)
a<-seq(0,1,length.out=(G+1))
b<-quantile(x0,probs=a)
WC<-rep(1,n0)
ep3<-rep(0,n0)
iter<-0
repeat{
iter<-iter+1
if(iter<=(G-1)){
WC[ep1>=b[iter] & ep1<b[iter+1]]<-iter
ep3[ep1>=b[iter] & ep1<b[iter+1]]<-mean(r[ep1>=b[iter] & ep1<b[iter+1]])
}
else if(iter>(G-1)){
WC[ep1>=b[iter]]<-iter
ep3[ep1>=b[iter]]<-mean(r[ep1>=b[iter]])
break
}
}
return(cbind(WC,ep3))
}

RES_WC<-fp(ep1,10)
ep3<-RES_WC[,2]
etheta_WC_p<-1/n*sum(r/ep3*y)

###Doubly robust method

#fit regression model of Y versus Z
yr<-y[r==1]
z1r<-z1[r==1]
z2r<-z2[r==1]
z3r<-z3[r==1]
z4r<-z4[r==1]

fit<-lm(yr~z1r+z2r+z3r+z4r)
ebeta<-fit$coefficients
em<-ebeta[1]+ebeta[2]*z1+ebeta[3]*z2+ebeta[4]*z3+ebeta[5]*z4
etheta_DR<-1/n*(sum(r/ep1*y)+sum((1-r/ep1)*em))





